<p align="left">
  <br><br><br>
  <img src="docs/content/media/hichipper_logo.png" width="50%"/>
</p>


[![Build Status](https://travis-ci.org/aryeelab/hichipper.svg?branch=master)](https://travis-ci.org/aryeelab/hichipper)
[![PyPI version](https://img.shields.io/badge/pypi-0.7.2-brightgreen.svg)](https://pypi.python.org/pypi/hichipper/)
[![Documentation Status](https://readthedocs.org/projects/hichipper/badge/?version=latest)](http://hichipper.readthedocs.io/en/latest/?badge=latest)
[![License: MIT](https://img.shields.io/badge/License-MIT-blue.svg)](https://opensource.org/licenses/MIT)
[![DOI](https://img.shields.io/badge/DOI-bioRxiv-red.svg)](https://www.biorxiv.org/content/early/2017/09/21/192302)
[![Join the chat at https://gitter.im/aryeelab/hichipper](https://badges.gitter.im/aryeelab/hichipper.svg)](https://gitter.im/aryeelab/hichipper?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)


This package is maintained by [Caleb Lareau](mailto:caleblareau@g.harvard.edu) in
the [Aryee Lab](http://aryee.mgh.harvard.edu/). Source code is made freely available
here and a packaged install version is provided through [PyPi](https://pypi.python.org/pypi/hichipper/).

## About
The **hichipper** package implements our data processing and quality control pipeline for 
[HiChIP](http://www.nature.com/nmeth/journal/vaop/ncurrent/full/nmeth.3999.html) data.
This package takes output from a [HiC-Pro](https://github.com/nservant/HiC-Pro)
run and a sample manifest file (`.yaml`)
that coordinates optional high-quality peaks (identified through ChIP-Seq) and
restriction fragment locations (see [folder here](RestrictionFragmentFiles))
as input and produces output that can be used to 1) determine library quality,
2) identify and characterize DNA loops and 3) interactively visualize loops.
Loops are assigned strength and confidence metrics that can be used to evaluate samples
individually or for differential analysis in
downstream tools like [diffloop](https://bioconductor.org/packages/release/bioc/html/diffloop.html).


We have used the library QC metrics with as few as 1 million reads, enabling library quality
to be assessed through shallow (and cheap) sequencing before performing a full depth sequencing run.

A graphical overview showing how **hichipper** integrates with other tools in the analysis of raw HiChIP data
is shown in the overview figure below. Detailed descriptions of the different branches of
input, output, and configuration for **hichipper** are discussed in the [documentation](http://hichipper.readthedocs.io).

![big1](docs/content/media/Big1.png)
![big2](docs/content/media/Big2.png)<br>

## Installation/Documentation/FAQ/.etc

Check out the [**hichipper** documentation](http://hichipper.readthedocs.io) for detailed
installation instructions, dependency configuration, and other information regarding the tool and its implementation.
<br><br>


## Workflow Overview
A simple graphical guide to processing HiChIP data is shown below. The role of **hichipper**
is to import aligned read files from (e.g. [HiC-Pro](https://github.com/nservant/HiC-Pro))
as well as location of restriction fragment files
([available here](https://github.com/aryeelab/hichipper/tree/master/RestrictionFragmentFiles)) coordinated through a
`.yaml` configuration file and produce user-friendly output. 

In particular, **hichipper** allows users to pre-supply their own set of gold-standard peaks (e.g. from ChIP-Seq)
or call peaks directly from HiChIP data using a novel background detection algorithm. In either case, interactions
and chromatin loops can be called using a restriction fragment-aware approach that substantially increases read density in loops. 
 
![hichipper_overview](docs/content/media/Overview.png)

## Quality control reports
In the [qcReports folder](qcReports), we collect the `.html` QC report files associated with text annotations
from the experiments performed in the [original HiChIP manuscript](http://www.nature.com/nmeth/journal/vaop/ncurrent/full/nmeth.3999.html)
as well as other reports generated by anonymous collaborators that demonstrate libraries that did not prepare well, likely due
to poor in situ ligation. To determine the quality of a new HiChIP library, we recommend comparing the vital statistics and 
interactive tables and figures between existing libraries. 


### Citation
If you use **hichipper** for your work, please cite:

Lareau, C.A. and Aryee, M.J. (2017) "hichipper: A preprocessing pipeline for assessing library quality and DNA loops from HiChIP data." _bioRxiv_ [doi: https://doi.org/10.1101/192302 ](https://www.biorxiv.org/content/early/2017/09/21/192302)

### Questions/comments/feedback
are always welcomed. The easiest way for us to have correspondence (if appropriate/interesting
for the public) is through raising a [new issue](https://github.com/aryeelab/hichipper/issues/new) or our [hichipper chat room on gitter](https://gitter.im/aryeelab/hichipper).
Otherwise, email [Caleb](mailto:caleblareau@g.harvard.edu) with any private concerns.
<br><br>
**hichipper** logo made with [autowide font](http://www.1001freefonts.com/audiowide.font) with these
[blue](http://www.color-hex.com/color/4b96c6) and [red](http://www.color-hex.com/color/bf5150)
color definitions.
<br><br>

# hichipper executable scripts

Below are some details of what's what in **hichipper**

### cli.py
The master coordinator file for running **hichipper** as implemented. See details 
[here](https://pythonhosted.org/pyCLI/). This is the script that is called when 
**hichipper** is evoked from the command line.

If interested in how peak files are coordinated, the `.yaml` is parsed, and how all the
rest of the scripts are stitched together, this is the place to look. 

### diffloop_work.R
R script that builds the `.rds` file and the `.mango` file. All filtered interaction 
files are read and and individually processed per sample.

### interactionsCall.sh
This is the main worker script given some set of defined anchors. Most user arguments
related to loops will be passed here. This will also generate the `.stat` file and a 
majority of the log file. 

### lambdaProcess.R
This script will perform the modified background correction implemented in **hichipper** where 
notably a smoothing spline function is fit over the mean treatment / background lambda. 

### qcReport.R
Token wrapper R script that renders the actual working script--

### qcReport_make.Rmd
Using `knitr` and related packages, this generated the `.html` file associated with 
the quality control report. It's pretty messy and peculiar so proceed with caution 
when reading it. 

### requirementsInstall.R
R script that isn't actually called at any point by **hichipper** but is useful for installing
dependencies as coordinated through the main README in github. 

### resFragAnchorProcess.R
This R script will adaptively pad a given bed file to the edges of the restriction fragments,
which should also be supplied by a user defined input. 

# hichipper tests

equivalent to running
```
hichipper --out output1 --peak-pad 1000 --skip-resfrag-pad --basic-qc --skip-diffloop yaml/one.yaml

# Now with absolute file paths
hichipper --out output1 --peak-pad 1000 --skip-resfrag-pad --basic-qc --skip-diffloop yaml/one_abs.yaml

```
and testing the output against something we think is correct

## Verify the `call` mode

```
hichipper call --out outputCallvi --restriction-frags ../RestrictionFragmentFiles/hg19_MboI_resfrag.bed.gz --peaks chipseq/GM12878_SMC3_ChIPSeq_chr22.narrowPeak --skip-resfrag-pad --basic-qc --skip-diffloop --input-vi call_inputs/dSRR3467177_allValidPairs 

```


## Other useful commands -- peak calling
```
hichipper --out combinedall --skip-diffloop yaml/example_COMBINED_ALL.yaml
hichipper --out combinedself --skip-diffloop yaml/example_COMBINED_SELF.yaml

hichipper --out eachall --skip-diffloop yaml/example_EACH_ALL.yaml
hichipper --out eachself --skip-diffloop yaml/example_EACH_SELF.yaml
```

#!/usr/bin/env Rscript

suppressMessages(suppressWarnings(require(GenomicRanges)))
suppressMessages(suppressWarnings(require(data.table)))

args <- commandArgs(trailingOnly = TRUE)
resfile <- args[1]
peaksfile <- args[2]

pad <- 0 # taken care of in the Python execution

# Import Restriction Fragments / Convert to GRanges
if(endsWith(resfile, "gz")){
  resFrags <- data.frame(fread(paste0(input = 'zcat < ', resfile), header = FALSE))
} else {
  resFrags <- data.frame(fread(resfile,  header = FALSE))
}
resFrags_g <- makeGRangesFromDataFrame(setNames(data.frame(
  resFrags[, 1], resFrags[, 2], resFrags[, 3]), c("seqnames", "start", "end")))

# Import Peaks / Convert to GRanges
if(endsWith(peaksfile, "gz")){
  peaks <- data.frame(fread(paste0(input = 'zcat < ', peaksfile), header = FALSE))
} else {
  peaks <- data.frame(fread(peaksfile,  header = FALSE))
}
peaks$start <- peaks$V2 - pad
peaks$end <- peaks$V3 + pad
peaks <- makeGRangesFromDataFrame(peaks, seqnames.field = "V1", start.field = "start", end.field = "end")

# Overlap the two; create GRanges of extreme fragments
ov <- findOverlaps(resFrags_g, peaks)
mins <- unname(tapply(queryHits(ov), subjectHits(ov), min))
maxs <-  unname(tapply(queryHits(ov), subjectHits(ov), max))

anchorsfin_g <- makeGRangesFromDataFrame(setNames(data.frame(
  resFrags[mins, 1], resFrags[mins, 2], resFrags[maxs, 3]), c("seqnames", "start", "end")))

anchors_g <- reduce(anchorsfin_g)

# Filter anchors that were on terminal restriction fragments
anchors_gfilt <- anchors_g[width(anchors_g) < 50000] 
cat(paste0("Anchors removed due to excessive size (likely at ends of chromosomes): ",
           as.character(length(anchors_g) - length(anchors_gfilt)), " \n"))
write.table(as.data.frame(anchors_gfilt)[,c(1,2,3)], row.names = FALSE, col.names = FALSE, quote = FALSE, 
            sep = "\t", file = paste0(peaksfile, "rf.tmp"))

#!/usr/bin/env Rscript

# File / set of functions that takes restriction enzyme fragment positions
# and bedgraph pileup files from MACS2 and writes modified files

suppressMessages(suppressWarnings(library(GenomicRanges)))
suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(reshape2)))

args <- commandArgs(trailingOnly = TRUE)
resfile <- args[1]
treatmentfile <- args[2]
backgroundfile <- args[3]
outdir <- args[4]
K <- 1000000 # Number of loci to sample from 

# Import Restriction Fragments / Convert to GRanges
if(endsWith(resfile, "gz")){
  resFrags <- data.frame(fread(paste0(input = 'zcat < ', resfile), header = FALSE))
} else {
  resFrags <- data.frame(fread(resfile,  header = FALSE))
}

resSites <- makeGRangesFromDataFrame(setNames(data.frame(
  resFrags[, 1], resFrags[, 2], resFrags[, 2]), c("seqnames", "start", "end")))

# Function that computes a vector of ratios per distance, the total mean,
# and returns the imported background peakset

computeRatioEtc <- function(treatmentfile, backgroundfile){
  
  # Import Treatment / Convert to GRanges
  if(endsWith(treatmentfile, "gz")){
    txt <- data.frame(fread(paste0(input = 'zcat < ', treatmentfile), header = FALSE))
  } else {
    txt <- fread(treatmentfile)
    txt <- txt[txt$V1 %in% seqnames(resSites),]
  }
  txt <- makeGRangesFromDataFrame(txt, seqnames.field = "V1", start.field = "V2", end.field = "V3", keep.extra.columns = TRUE)
  
  # Import Control / Convert to GRanges
  if(endsWith(backgroundfile, "gz")){
    cont <- data.frame(fread(paste0(input = 'zcat < ', backgroundfile), header = FALSE))
  } else {
    cont <- fread(backgroundfile)
    cont <- cont[cont$V1 %in% seqnames(resSites),]
  }
  cont <- makeGRangesFromDataFrame(cont, seqnames.field = "V1", start.field = "V2", end.field = "V3", keep.extra.columns = TRUE)
  
  #Sample sites from the genome; make GRanges object
  chroms <- intersect(levels(seqnames(txt)), levels(seqnames(resSites)))
  begins <- tapply(start(txt)[mcols(txt)[,1] != 0 ] , seqnames(txt)[mcols(txt)[,1] != 0 ], min)[chroms]
  ends <- tapply(end(txt)[mcols(txt)[,1] != 0 ] , seqnames(txt)[mcols(txt)[,1] != 0 ], max)[chroms]
  dists <- ends - begins
  nsamples <- round(K * (dists/sum(as.numeric(dists))),digits = 0)
  samplefn <- function (chrom) sample((begins[chrom]:ends[chrom]), nsamples[chrom], replace = FALSE, prob = NULL)
  randGRanges <- makeGRangesFromDataFrame(reshape2::melt(setNames(lapply(chroms, samplefn), chroms)),
                                          seqnames.field = "L1", start.field = "value", end.field = "value")
  
  # Compute vector of distances to cutsite from random peaks; aggregate controls and treatment counts
  nndist <- mcols(distanceToNearest(randGRanges, resSites))[,1]
  txtVals <- mcols(txt)[findOverlaps(randGRanges, txt, select = "arbitrary"),1]
  contVals <- mcols(cont)[findOverlaps(randGRanges, cont, select = "arbitrary"),1]
  
  # Compute nearest neighbor for background
  mid <- (start(cont) + end(cont))/2
  backmid <- as(data.frame(chrom=seqnames(cont), start=mid, end=mid), "GRanges")
  mcols(cont)$dist <- mcols(distanceToNearest(backmid, resSites))[,1]
  
  vals <- tapply(txtVals/contVals, nndist, mean)
  
  # Write adjusted treatment (only filters out regions where no restriction enzyme information is contained)
  outdf <- data.frame(x1 = seqnames(txt), x2 = start(txt), x3 = end(txt), x4 = round(mcols(txt)[,1],2))
  write.table(outdf, file = paste0(outdir, "/adjustedTreatment.bdg.tmp"), sep = "\t", row.names = FALSE, quote = FALSE, col.names = FALSE)
  return(list(vals[1:750], mean(txtVals/contVals), cont))
}

hichipall <- computeRatioEtc(treatmentfile, backgroundfile)
hichipratio <- hichipall[[1]]
hichipmean <-  hichipall[[2]]
hichipbg   <-  hichipall[[3]]

# Compute smooth trajectory; scale factor per background set
smoothingSpline <- smooth.spline(as.numeric(names(hichipratio)), unname(hichipratio), spar=0.35)
scaleVec <- c(smoothingSpline$y/hichipmean, rep(1, max(mcols(hichipbg)$dist)- length(smoothingSpline$y) + 1))
names(scaleVec) <- as.character(0:(length(scaleVec)-1))

# Make scale factor; write to new file
dist <- mcols(hichipbg)[,"dist"]
sf <- scaleVec[dist+1] # shift for zero
outdf <- data.frame(x1 = seqnames(hichipbg), x2 = start(hichipbg), x3 = end(hichipbg), x4 = round(mcols(hichipbg)[,1]*sf,2))
globalLambda <- min(mcols(hichipbg)[,1])
outdf[outdf[,4] < globalLambda,4] <- globalLambda
write.table(outdf, file = paste0(outdir, "/adjustedBackground.bdg.tmp"), sep = "\t", row.names = FALSE, quote = FALSE, col.names = FALSE)
write.table(data.frame(round(hichipmean,2)),  file = paste0(outdir, "/globalMeanRatio.tmp"), sep = "\t", row.names = FALSE, quote = FALSE, col.names = FALSE)

tdf <- head(hichipratio, 750)
write.table(data.frame(dist = names(tdf), vals = round(unname(tdf),3)), file = paste0(outdir, "/observedRatios.tmp"), sep = "\t", row.names = FALSE, quote = FALSE, col.names = FALSE)

install_pkgs <- function(pkg){
    new.pkg <- pkg[!(pkg %in% installed.packages()[, "Package"])]
    if (length(new.pkg)) install.packages(new.pkg, dependencies = TRUE)
}
install_pkgs(c("DT", "data.table", "devtools", "foreach", "ggplot2", "knitr", "networkD3", "readr", "reshape2"))

source("https://bioconductor.org/biocLite.R")
install_pkgs_bioc <- function(pkg){
    new.pkg <- pkg[!(pkg %in% installed.packages()[, "Package"])]
    if (length(new.pkg)) biocLite(new.pkg, dependencies = TRUE)
}
install_pkgs_bioc(c("diffloop"))

#!/usr/bin/env Rscript
args <- commandArgs(trailingOnly = TRUE)
options(warn=-1)

scriptdir <- args[1]
outdir <- args[2]
cwd <- args[3]
version <- args[4]
samples <- unlist(strsplit(args[seq(-1,-4)], split = " "))

cat(getwd())
rmarkdown::render(paste0(outdir,"/qcReport_make.Rmd"), params = list(
  scriptdir = scriptdir, 
  outdir = outdir, 
  cwd = cwd, 
  samples = samples,
  version = version
), quiet = TRUE, output_file=paste0(outdir, ".hichipper.qcreport.html"))

#!/usr/bin/env Rscript
args <- commandArgs(trailingOnly = TRUE)

cwd <- args[1]
outdir <- args[2]
samples <- unlist(strsplit(args[c(-1,-2)], split = " "))

suppressMessages(suppressWarnings(library(diffloop)))
suppressMessages(suppressWarnings(library(foreach)))

message("Processing: ", samples)

# Do everything per-sample
tmp <- foreach(sample = samples, .combine="rbind") %do% {
  s <- loopsMake(outdir, samples = paste0(sample, ".filt.intra"), mergegap = 0)
  sampleNames(s) <- sample
  mango_filt_df <- summary(mangoCorrection(s))
  df_filt <- mango_filt_df[,c(1,2,3,4,5,6,7,9)]
  s <- rmchr(s)
  col <- mango_filt_df[,9] < 0.01
  col[col] <- "none"
  col[col=="FALSE"] <- "ns"
  s@rowData$loop.type <- col
  saveRDS(s, file = paste0(outdir, "/", sample, "-HiChIP.rds"))
  write.table(df_filt, sep = "\t", row.names = FALSE, col.names = FALSE, quote = FALSE,
              file = paste0(outdir, "/", sample, ".interactions.all.mango"))
}

library(RJSONIO)

s1 <- data.frame(
  type="longrange",
  url=URL_SAMPLE1,
  name=SAMPLE1,
  mode="arc",
  colorpositive="#00441B",  # change colors as appropriate
  height="50"
)

s2 <- data.frame(
  type="longrange",
  url=URL_SAMPLE2,
  name=SAMPLE2,
  mode="arc",
  colorpositive="#00441B", # change colors as appropriate
  height="50"
)

exportJson <- toJSON(do.call(rbind, list(s1,s2)))
write(exportJson, "washu_tracks.json")

#!/bin/bash

# Parse parameters
WK_DIR=$1
OUT_NAME=$2
HICPRO_OUT=$3
SAMPLE=$4
PEAKFILE=$5
MIN_DIST=$6
MAX_DIST=$7
MERGE_GAP=$8
HALF_LEN=$9

# Log from the shell script side
LOG_FILE="${WK_DIR}/${OUT_NAME}/${OUT_NAME}.hichipper.log"
echo "`date`: Processing ${SAMPLE}" | tee -a $LOG_FILE

# Summary stats
Total_PETs=`head -1 "${WK_DIR}/${HICPRO_OUT}/bowtie_results/bwt2/${SAMPLE}/"*pairstat | awk '$2 > 0 && $2 < 10000000000 {sum += $2}; {print sum}' | awk '{print $1}'`
echo "`date`: Total_PETs=${Total_PETs}" | tee -a $LOG_FILE
Mapped_unique_quality_pairs=`cat "${WK_DIR}/${HICPRO_OUT}/hic_results/data/${SAMPLE}/"*Pairs | wc -l | awk '{print $1}'`
echo "`date`: Mapped_unique_quality_pairs=${Mapped_unique_quality_pairs}" | tee -a $LOG_FILE
Mapped_unique_quality_valid_pairs=`cat "${WK_DIR}/${HICPRO_OUT}/hic_results/data/${SAMPLE}/"*validPairs | wc -l | awk '{print $1}'`
echo "`date`: Mapped_unique_quality_valid_pairs=${Mapped_unique_quality_valid_pairs}"| tee -a $LOG_FILE

# Merge gaps; check bedtools
echo "`date`: Intersecting PETs with anchors" | tee -a $LOG_FILE
sortBed -i "${WK_DIR}/${PEAKFILE}" | bedtools merge -d $MERGE_GAP -i stdin > "${WK_DIR}/${OUT_NAME}/${SAMPLE}_temporary_peaks.merged.bed.tmp"
if [ ! -f  "${WK_DIR}/${OUT_NAME}/${SAMPLE}_temporary_peaks.merged.bed.tmp" ] ; then
    echo "Bedtools does not exist, but we need it" | tee -a $LOG_FILE
    exit
fi

# Count reads in anchors; spit out only valid pairs sorted and pretty
cat "${WK_DIR}/${HICPRO_OUT}/hic_results/data/${SAMPLE}/"*Pairs | awk -v RL="$HALF_LEN" '{print $2 "\t" $3 - RL "\t" $3 + RL}' | awk '$2 > 0 {print $0}' | coverageBed -a stdin -b "${WK_DIR}/${OUT_NAME}/${SAMPLE}_temporary_peaks.merged.bed.tmp" -counts | awk '{sum += $4} END {print sum}' > "${WK_DIR}/${OUT_NAME}/${SAMPLE}.peakReads.tmp"
cat "${WK_DIR}/${HICPRO_OUT}/hic_results/data/${SAMPLE}/"*Pairs | awk -v RL="$HALF_LEN" '{print $5 "\t" $6 - RL "\t" $6 + RL}' | awk '$2 > 0 {print $0}' | coverageBed -a stdin -b "${WK_DIR}/${OUT_NAME}/${SAMPLE}_temporary_peaks.merged.bed.tmp" -counts | awk '{sum += $4} END {print sum}' >> "${WK_DIR}/${OUT_NAME}/${SAMPLE}.peakReads.tmp"
cat "${WK_DIR}/${HICPRO_OUT}/hic_results/data/${SAMPLE}/"*validPairs | awk -v RL="$HALF_LEN" '{if ($2<$5 || ($2==$5 && $3<=$6)) print $2,$3-RL,$3+RL,$5,$6-RL,$6+RL; else print $5,$6-RL,$6+RL,$2,$3-RL,$3+RL}' 'OFS=\t' | awk '$2 > 0 && $5 > 0 {print $0}' | sort -k1,1n -k2,2n -k4,4n -k5,5n > "${WK_DIR}/${OUT_NAME}/${SAMPLE}_interactions.bedpe.tmp"
READS_IN_ANCHORS=`awk '{sum += $1} END {print sum}' "${WK_DIR}/${OUT_NAME}/${SAMPLE}.peakReads.tmp" | awk '{print $1}'`

# Valid interaction statistics
intrachromosomal_valid_small=`awk -v MIN_DIST="$MIN_DIST" '$1 == $4 && (($5+$6)/2 - ($2+$3)/2)<=MIN_DIST {print $0}' "${WK_DIR}/${OUT_NAME}/${SAMPLE}_interactions.bedpe.tmp" | wc -l | awk '{print $1}'`
echo "`date`: Intrachromosomal_valid_small=${intrachromosomal_valid_small}" | tee -a $LOG_FILE
intrachromosomal_valid_med=`awk -v MIN_DIST="$MIN_DIST" -v MAX_DIST="$MAX_DIST" '$1 == $4 && (($5+$6)/2 - ($2+$3)/2)>=MIN_DIST && (($5+$6)/2 - ($2+$3)/2)<=MAX_DIST {print $0}' "${WK_DIR}/${OUT_NAME}/${SAMPLE}_interactions.bedpe.tmp" | wc -l | awk '{print $1}'`
echo "`date`: Intrachromosomal_valid_med=${intrachromosomal_valid_med}" | tee -a $LOG_FILE
intrachromosomal_valid_large=`awk -v MAX_DIST="$MAX_DIST" '$1 == $4 && (($5+$6)/2 - ($2+$3)/2)>=MAX_DIST {print $0}' "${WK_DIR}/${OUT_NAME}/${SAMPLE}_interactions.bedpe.tmp" | wc -l | awk '{print $1}'`
echo "`date`: Intrachromosomal_valid_large=${intrachromosomal_valid_large}" | tee -a $LOG_FILE
intrachoromosomal_valid_all=$(($intrachromosomal_valid_small+$intrachromosomal_valid_med+$intrachromosomal_valid_large))

NUM_PEAKS=`wc -l "${WK_DIR}/${OUT_NAME}/${SAMPLE}_temporary_peaks.merged.bed.tmp" | awk '{print $1}'`
echo "`date`: Total number of anchors used: ${NUM_PEAKS}" | tee -a $LOG_FILE
echo "`date`: Total number of reads in anchors: ${READS_IN_ANCHORS}" | tee -a $LOG_FILE

# Overlap reads with anchors
cat "${WK_DIR}/${OUT_NAME}/${SAMPLE}_interactions.bedpe.tmp" | awk '{print $1"\t"$2"\t"$3}' | bedtools intersect -loj -a stdin -b "${WK_DIR}/${OUT_NAME}/${SAMPLE}_temporary_peaks.merged.bed.tmp" | awk '{print $4,$5,$6}' OFS='\t' > "${WK_DIR}/${OUT_NAME}/${SAMPLE}_anchor1.bed.tmp"
cat "${WK_DIR}/${OUT_NAME}/${SAMPLE}_interactions.bedpe.tmp" | awk '{print $4"\t"$5"\t"$6}' | bedtools intersect -loj -a stdin -b "${WK_DIR}/${OUT_NAME}/${SAMPLE}_temporary_peaks.merged.bed.tmp" | awk '{print $4,$5,$6}' OFS='\t' > "${WK_DIR}/${OUT_NAME}/${SAMPLE}_anchor2.bed.tmp"

paste "${OUT_NAME}/${SAMPLE}_anchor1.bed.tmp" "${OUT_NAME}/${SAMPLE}_anchor2.bed.tmp" | awk '{if ($1 != "." && $4 != ".") print}' > "${WK_DIR}/${OUT_NAME}/${SAMPLE}_anchor.interactions.bedpe.tmp"
cut -f1-6  "${OUT_NAME}/${SAMPLE}_anchor.interactions.bedpe.tmp" | sort | uniq -c | awk '{print $2,$3,$4,$5,$6,$7,".",$1}' >  "${WK_DIR}/${OUT_NAME}/${SAMPLE}.loop_counts.bedpe.tmp"
Mapped_unique_intra_quality_anchor=`awk '$1 == $4 {print $0}' "${WK_DIR}/${OUT_NAME}/${SAMPLE}_anchor.interactions.bedpe.tmp" | wc -l | awk '{print $1}'`
Mapped_unique_intra_quality_anchor_small=`awk -v MIN_DIST="$MIN_DIST" '$1 == $4 && (($5+$6)/2 - ($2+$3)/2)<=MIN_DIST {print $0}' "${WK_DIR}/${OUT_NAME}/${SAMPLE}_anchor.interactions.bedpe.tmp" | wc -l | awk '{print $1}'`
Mapped_unique_intra_quality_anchor_med=`awk -v MIN_DIST="$MIN_DIST" -v MAX_DIST="$MAX_DIST" '$1 == $4 && (($5+$6)/2 - ($2+$3)/2)>=MIN_DIST && (($5+$6)/2 - ($2+$3)/2)<=MAX_DIST {print $0}' "${WK_DIR}/${OUT_NAME}/${SAMPLE}_anchor.interactions.bedpe.tmp" | wc -l | awk '{print $1}'`
Mapped_unique_intra_quality_anchor_large=`awk -v MAX_DIST="$MAX_DIST" '$1 == $4 && (($5+$6)/2 - ($2+$3)/2)>=MAX_DIST {print $0}' "${WK_DIR}/${OUT_NAME}/${SAMPLE}_anchor.interactions.bedpe.tmp" | wc -l | awk '{print $1}'`
echo "`date`: Mapped_unique_intra_quality_anchor=${Mapped_unique_intra_quality_anchor}" | tee -a $LOG_FILE
echo "`date`: Mapped_unique_intra_quality_anchor_small=${Mapped_unique_intra_quality_anchor_small}" | tee -a $LOG_FILE
echo "`date`: Mapped_unique_intra_quality_anchor_med=${Mapped_unique_intra_quality_anchor_med}" | tee -a $LOG_FILE
echo "`date`: Mapped_unique_intra_quality_anchor_large=${Mapped_unique_intra_quality_anchor_large}" | tee -a $LOG_FILE

# Produce final output
awk '$1 != $4 {print $0}' "${WK_DIR}/${OUT_NAME}/${SAMPLE}.loop_counts.bedpe.tmp" > "${WK_DIR}/${OUT_NAME}/${SAMPLE}.inter.loop_counts.bedpe"
awk '$1 == $4 {print $0}' "${WK_DIR}/${OUT_NAME}/${SAMPLE}.loop_counts.bedpe.tmp" > "${WK_DIR}/${OUT_NAME}/${SAMPLE}.intra.loop_counts.bedpe"
awk -v MIN_DIST="$MIN_DIST" -v MAX_DIST="$MAX_DIST" '$1 == $4 && $2 != $5 && (($5+$6)/2 - ($2+$3)/2)>=MIN_DIST && (($5+$6)/2 - ($2+$3)/2)<=MAX_DIST {print $0}' "${WK_DIR}/${OUT_NAME}/${SAMPLE}.loop_counts.bedpe.tmp" > "${WK_DIR}/${OUT_NAME}/${SAMPLE}.filt.intra.loop_counts.bedpe"

# Finalize 
Loop_PETs=`awk '{sum += $8} END {print sum}' "${WK_DIR}/${OUT_NAME}/${SAMPLE}.filt.intra.loop_counts.bedpe"`
echo "`date`: Loop_PETs=${Loop_PETs}" | tee -a $LOG_FILE

# Write out summary statistics
echo "Total_PETs=${Total_PETs}" > "${WK_DIR}/${OUT_NAME}/${SAMPLE}.stat"

echo "Mapped_unique_quality_pairs=${Mapped_unique_quality_pairs}" >> "${WK_DIR}/${OUT_NAME}/${SAMPLE}.stat"
echo "Mapped_unique_quality_valid_pairs=${Mapped_unique_quality_valid_pairs}" >> "${WK_DIR}/${OUT_NAME}/${SAMPLE}.stat"
echo "Mapped_unique_quality_valid_intrachromosomal=${intrachoromosomal_valid_all}" >> "${WK_DIR}/${OUT_NAME}/${SAMPLE}.stat"
echo "Intrachromosomal_valid_small=${intrachromosomal_valid_small}" >> "${WK_DIR}/${OUT_NAME}/${SAMPLE}.stat"
echo "Intrachromosomal_valid_med=${intrachromosomal_valid_med}" >> "${WK_DIR}/${OUT_NAME}/${SAMPLE}.stat"
echo "Intrachromosomal_valid_large=${intrachromosomal_valid_large}" >> "${WK_DIR}/${OUT_NAME}/${SAMPLE}.stat"
echo "Mapped_unique_intra_quality_anchor=${Mapped_unique_intra_quality_anchor}" >> "${WK_DIR}/${OUT_NAME}/${SAMPLE}.stat"
echo "Mapped_unique_intra_quality_anchor_small=${Mapped_unique_intra_quality_anchor_small}" >> "${WK_DIR}/${OUT_NAME}/${SAMPLE}.stat"
echo "Mapped_unique_intra_quality_anchor_med=${Mapped_unique_intra_quality_anchor_med}" >> "${WK_DIR}/${OUT_NAME}/${SAMPLE}.stat"
echo "Mapped_unique_intra_quality_anchor_large=${Mapped_unique_intra_quality_anchor_large}" >> "${WK_DIR}/${OUT_NAME}/${SAMPLE}.stat"
echo "Number_of_Anchors=${NUM_PEAKS}" >> "${WK_DIR}/${OUT_NAME}/${SAMPLE}.stat"
echo "MIN_LENGTH=${MIN_DIST}" >> "${WK_DIR}/${OUT_NAME}/${SAMPLE}.stat"
echo "MAX_LENGTH=${MAX_DIST}" >> "${WK_DIR}/${OUT_NAME}/${SAMPLE}.stat"
echo "READS_IN_ANCHORS=${READS_IN_ANCHORS}" >> "${WK_DIR}/${OUT_NAME}/${SAMPLE}.stat"

---
title: "hichipper QC report"
date: "`r Sys.Date()`"
params:
   outdir: ""
   scriptdir: ""
   samples: ""
   cwd: ""
   version: ""
output:
  rmarkdown::html_vignette:
    fig_caption: yes
vignette: >
  %\VignetteIndexEntry{hichipper QC report}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, echo=FALSE, message=TRUE, warning=TRUE}
suppressMessages(library(ggplot2))
suppressMessages(library(foreach))
suppressMessages(library(reshape2))
suppressMessages(library(readr))
suppressMessages(library(knitr))
suppressMessages(library(DT))
suppressMessages(library(networkD3))

options(scipen=999)

outdir <- params$outdir
scriptdir <- params$scriptdir
samples <- params$samples
cwd <- params$cwd
version <- params$version

```
hichipper, version `r version`. 

```{r, echo=FALSE, message=FALSE, warning=FALSE}
# Most of the work/parsing
min_length <- 0
max_length <- 0
anchors <- data.frame()

# Creates a dataframe of summary statistics from the individual sample log output files
readstats <- foreach(sample = samples, .combine="rbind") %do% {
  sfilename <- "/Users/lareauc/Downloads/ESO26_separate/ESO26_r1.stat"
  #sfilename <- file.path(paste0(cwd, "/", outdir, "/", sample, ".stat"))
  rs <- read.table(sfilename, header=FALSE, stringsAsFactors = FALSE, sep = "=")
  anchors <- rbind(anchors, data.frame(sample= sample, npeaks = rs[12,2] ))
  min_length <- rs[13,2]
  max_length <- rs[14,2]
  readsinanchors <- rs[15,2]
  rso <- cbind(sample=sample, rs[c(1:8, 10, 15),])
  colnames(rso) <- c("sample", "metric", "count")
  rso
}

mincar <- paste0(round(as.numeric(min_length)/1000), "Kb")
maxcar <- paste0(round(as.numeric(max_length)/1000000), "Mb")


np <- paste0("Valid_Intra_", mincar, "-",  maxcar)
npa <- paste0("Valid_Intra_anchor_", mincar,"-", maxcar)
metrics <- c("Total_PETs", "Mapped_unique_quality", "Mapped_unique_quality_valid", "Valid_Intra", #1-4
             paste0("Valid_Intra_<", mincar), np, #5,6
             paste0("Valid_Intra_>", maxcar), #7
             paste0("Valid_Intra_anchor"), npa, "HQ_Reads_In_Anchors") #8, 10, 15

readstats$metric <- factor(rep(metrics, length(samples)), levels=metrics)

# Organize summary tables

tab <- suppressMessages(acast(readstats, metric~sample, sum))
tab <- rbind(tab, Long_Range_Interactions = tab[6,] + tab[7,])
tab_percent <- 100*sweep(tab, 2, tab["Total_PETs",], FUN="/")
tab_summary <- rbind(format(tab_percent[c(9,11,2,10),,drop = FALSE], digits = 2, nsmall = 2), 
                     as.character(tab[1,,drop = FALSE]) )
rownames(tab_summary) <- c(paste0("% in Loops"),
                           "% Long Range Interaction",
                           "% HQ Unique Mapped",
                           "% Reads in Anchors",
                           "Total PETs")
tab_summary <- tab_summary[5:1,, drop = FALSE]

if(dim(tab)[2] == 1){
  intraSum <- sum(tab[c(5,6,7),])
}else {
  intraSum <- colSums(tab[c(5,6,7),])
}

tab_summary2 <- rbind(intraSum,
                      format(tab[5,]/intraSum * 100, digits = 2, nsmall = 2),
                      format(tab[6,]/intraSum * 100, digits = 2, nsmall = 2),
                      format(tab[7,]/intraSum * 100, digits = 2, nsmall = 2))
r <-  paste0(round(min_length/1000), "KB-",  round(max_length/1000000), "Mb")
rownames(tab_summary2) <- c("Intrachromasomal PETs",
                            paste0("% Reads < ", mincar),
                            paste0("% Reads in ",r),
                            paste0("% Reads > ", maxcar))
colnames(tab_summary2) <- colnames(tab_summary)

```

## Sankey Diagrams
Hover your mouse on any edge of the network to see the proportion of PETs that each edge represents. 100 defines the total number of reads originally used as input contained in the `.bam` file while the proportion at the end that is "In Anchors" corresponds to the number of loops. <br><br><br> 

```{r, echo=FALSE, message=FALSE, warning=FALSE, results='asis'}

for(sample in samples){
  
  dat <- readstats[readstats[,1] == sample,3]
  total <- dat[1]
  
  total_mapped <- dat[2]/total * 100
  total_unmapped <- 100 - total_mapped 
  mapped_u <- dat[3]/total * 100
  mapped_nu <- total_mapped - mapped_u
  u_i <- dat[4]/total * 100
  u_ni <- mapped_u - u_i
  i_small <- u_i * dat[5]/sum(dat[c(5,6,7)])
  i_med <-  u_i * dat[6]/sum(dat[c(5,6,7)])
  i_big <-  u_i * dat[7]/sum(dat[c(5,6,7)])
  med_anchor <- dat[9]/total * 100
  med_nanchor <- i_med - med_anchor
  
  nodes <- data.frame(name = c("Total", "Not in Loops", "HQ_Mapped", "Unique", "Intra", "<5kb", ">2Mb", "5kb-2Mb", "In Anchors"),
                      g = c("a", "c", rep("a", 3), "c", "c", "a", "a"))
  
  links <- data.frame(source = c(0,0,2,2,3,3,4,4,4,5,6,7,7), target = c(2,1,3,1,4,1,5,6,7,1,1,8,1),
                      value = c(total_mapped, total_unmapped, mapped_u, mapped_nu, u_i, u_ni,
                                i_small, i_big, i_med,  i_small, i_big, med_anchor, med_nanchor),
                      g = c("b", "d", "b", "d", "b", "d", "d", "d", "b", "d", "d", "b", "d" ))
  
  df <- list(nodes = nodes, links = links)
  
  cat(paste0(' \n \n \n ', sample)) 
  
  .pl <- sankeyNetwork(Links = df$links, Nodes = df$nodes, Source = "source",
                Target = "target", Value = "value", NodeID = "name", nodePadding = 30,
                fontSize = 12, nodeWidth = 30, fontFamily = "Arial", NodeGroup = "g",
                LinkGroup = "g", colourScale = JS("d3.scale.category10()"), margin = list(0,0,0,0),
                width = "100%", height = "100%")
 
  cat(knit(text = knit_expand(text = sprintf("```{r %s, echo=FALSE, message=FALSE} \n .pl \n```", paste0("san", sample))), quiet = TRUE))
}

```

## Summary Tables
```{r, echo=FALSE, message=FALSE, warning=FALSE, out.width='\\textwidth'}
datatable(tab_summary, class = 'cell-border stripe')
```


The first summary table notes how many PETs are in each sample and what fraction were mapped with high-quality. First, the "% Reads in Anchors" takes all unique, mappable pairs (whether they are valid, dangling, self-circle, etc. doesn't matter) and determines what fraction have both overlapping with anchor loci. Note, this numer should give an indication of the ChIP quality, but it may be sensitive to how peaks are determined with padding, etc. While the "% HQ Unique Mapped" reads should be self explanatory, the "% Long Range Interaction" value represents the number of intrachromosomal reads longer than the minimum length (default 5Kb) specified by the user and is a good approximation for the efficacy of the in situ ligation. Finally, the "% in Loops" is the fraction of total reads that are in loops, defined by high-quality, mapped intrachromosomal, anchor-mapped, between min and max lengths (default 5Kb and 2Mb). If the proportion of loops reads is low but the proportion of long range interactions is high, this suggests that the ChIP efficiency is relatively low. <br><br><br>

```{r, echo=FALSE, message=FALSE, warning=FALSE, out.width='\\textwidth'}
datatable(tab_summary2, class = 'cell-border stripe')
```


The second summary table shows the total number of intrachromosomal pets and the distance that they span binned by the max and min user defined distances. Only reads in the middle are used when making loops but all are used for anchor calling. If the very long interactions are disproportionately abundant, the proximity ligation step may not have been effective. In contrast, if the short range interactions are disproportionately abundant, issues with the in situ ligation likely occurred in the experiment. <br><br><br>

## Loop Width Distribution Histogram
```{r, echo=FALSE, message=FALSE, warning=FALSE, results='asis', out.width='\\textwidth', fig.width=7}

# Old Read Stats... plot read stats
#cd <- c("#B2182B", "#EF8A62", "#FDDBC7", "#D1E5F0", "#67A9CF", "#2166AC", "#A3A1A1", "gray84","#F7A128")
#p_metrics <- ggplot(readstats, aes(x = sample, y = count, fill=metric))  + 
#  geom_bar(stat='identity', position=position_dodge()) + theme_bw() + 
#  ggtitle("Counts") + xlab("") + scale_fill_manual(values=cd) +
#  theme(axis.text.x=element_text(angle=90,hjust=1,vjust=0.5))  + scale_y_continuous(labels=comma)


# Get loop lengths for histogram
loop_pets <- foreach(sample = samples) %do% {
  sfilename <- file.path(paste0(cwd, "/",outdir, "/",sample , ".intra.loop_counts.bedpe"))
  x <- suppressMessages(read_delim(sfilename, " ", col_names = FALSE, progress = FALSE))
  intra <- x[,1]==x[,4]
  x <- x[intra,]
  loop_length <- rep(as.numeric(((x[, 5]+ x[, 6])/2 - (x[, 2] + x[, 3])/2)[[1]]), as.numeric((x[, 8])[[1]]))
  df <- data.frame(loop_length = pmax(0, loop_length))
  pl1 <- ggplot(df, aes(loop_length)) + geom_histogram(bins = 40) + scale_x_log10() +
    theme_bw() +labs(title = paste0(sample, " Loop Width Distribution >", mincar), x = "Loop Length")  
  cat(knit(text = knit_expand(text = sprintf("```{r %s, echo=FALSE, message=FALSE, warning=FALSE, out.width='\\textwidth', fig.width=7 } \n pl1 \n```", paste0("hist", sample))), quiet = TRUE))
}
cat(paste0(' \n \n \n '))

```
Above is a histogram of the loop widths greater than the minimum distance supplied in the parameters. Note that the loops smaller than the minimum distance have been filtered to make the histogram more interpretable (refer to the table above to see the proportion of very loops below the minimum distance, which are likely self-ligations). 
<br>

## Raw Read Stats
```{r, echo=FALSE, message=FALSE, warning=FALSE, out.width='\\textwidth'}
datatable(format(acast(readstats, metric~sample, sum), big.mark=",")[-8,, drop = FALSE], class = 'cell-border stripe')
```
<br>

## Proportional Read Stats
```{r, echo=FALSE, message=FALSE, warning=FALSE, out.width='\\textwidth'}
datatable(format(tab_percent[c(-8,-10),,drop = FALSE], digits=2, nsmall=2), class = 'cell-border stripe')
```
<br>

## Number of Anchor Peaks
```{r, echo=FALSE, message=FALSE, warning=FALSE, out.width='\\textwidth'}
datatable(anchors, rownames = FALSE, class = 'cell-border stripe')
```


The number of anchor peaks used in each sample. In lowly sequenced samples, these numbers may be low and be responsible for the lack of PETs mapping into loops. <br> <br>
